unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.ScrollBox, FMX.Memo;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

uses
  System.TypInfo, System.Devices, FMX.Platform, System.Rtti;

procedure TForm1.FormShow(Sender: TObject);
var
  disp: IFMXDeviceMetricsService;
  dev: IFMXDeviceService;
  devCls: TDeviceInfo.TDeviceClass;
  w, h: Integer;
  Flg1, Flg2: Boolean;
begin
  OnShow := nil;
  if TPlatformServices.Current.SupportsPlatformService(IFMXDeviceMetricsService) then
    begin
      disp := IFMXDeviceMetricsService(TPlatformServices.Current.GetPlatformService(IFMXDeviceMetricsService));
      Flg1 := disp.GetDisplayMetrics.RawScreenSize.cx < disp.GetDisplayMetrics.RawScreenSize.cy;
      Flg2 := disp.GetDisplayMetrics.PhysicalScreenSize.cx < disp.GetDisplayMetrics.PhysicalScreenSize.cy;
      if (Flg1 and Flg2) or ((not Flg1) and (not Flg2)) then
        begin
          w := disp.GetDisplayMetrics.RawScreenSize.cx;
          h := disp.GetDisplayMetrics.RawScreenSize.cy;
        end
      else
        begin
          w := disp.GetDisplayMetrics.RawScreenSize.cy;
          h := disp.GetDisplayMetrics.RawScreenSize.cx;
        end;
      Memo1.Lines.Add(Format('ScreenSize: %dx%d', [w, h]));
      Memo1.Lines.Add(Format('Physical: %dx%d'  , [disp.GetDisplayMetrics.PhysicalScreenSize.cx,
                                                   disp.GetDisplayMetrics.PhysicalScreenSize.cy]));
      Memo1.Lines.Add(Format('Logical: %dx%d'   , [Self.ClientWidth, Self.ClientHeight]));
      Memo1.Lines.Add(Format('PPI: %d'          , [disp.GetDisplayMetrics.PixelsPerInch]));
    end;
  if TPlatformServices.Current.SupportsPlatformService(IFMXDeviceService) then
    begin
      dev := IFMXDeviceService(TPlatformServices.Current.GetPlatformService(IFMXDeviceService));
      devCls := dev.GetDeviceClass;
      Memo1.Lines.Add('Class: ' + GetEnumName(TypeInfo(TDeviceInfo.TDeviceClass), Ord(devCls)));
    end;
end;

end.
